///<reference path="../typings/knockout/knockout.d.ts" />
/// <reference path="../typings/jquery/jquery.d.ts" />
/// <reference path="Tool.ts" />
/// <reference path="Cell.ts" />
/// <reference path="LoadCharSet.ts" />
/// <reference path="Editor.ts" />
var ed;
var lc;
window.onload = function () {
    var editor = new Editor();
    ed = editor;
    var loadChars = new LoadCharSet();
    var i = new Input();
    ko.applyBindings(editor);
    lc = loadChars;
    editor.ts.setupTools();
    editor.init();
    setupSubscriptions(editor);
    $("#loading").hide();
    $("#wrapper").show();
    $("#moregames").show();
    $("body").keyup(function (event) {
        i.KeyUp(String.fromCharCode(event.which));
    });
    $("body").keydown(function (event) {
        i.KeyDown(String.fromCharCode(event.which));
    });
    $("body").keypress(function (event) {
        i.keyPress(String.fromCharCode(event.which));
    });
};
function setupSubscriptions(editor) {
    // TODO : how to do this nicely?
    editor.width.subscribe(function (newWidth) {
        editor.changedWidth(newWidth);
    });
    editor.height.subscribe(function (newHeight) {
        editor.changedHeight(newHeight);
    });
}
function load_chars() {
    var callback = function (data, textStatus, xhr) {
        var chars = data.split('\n');
        for (var c = 0; c <= chars.length; c++) {
            try {
                if (chars[c] && (chars[c].indexOf("gif") > 0)) {
                    $("#preLoadChars").append("<span><img alt='' title='' id='char_" + c + "' src='/graphics/" + chars[c] + "' /></span>");
                    var i = parseInt(chars[c].replace('bitmap', '').replace('.gif\r', ''));
                }
            }
            catch (err) {
                alert('error' + err);
            }
        }
    };
    var scr = this.load_file('chars.txt', callback);
}
function load_file(fileName, callback) {
    var jqxhr = $.ajax('/data/' + fileName)
        .done(function (data) {
        return data;
    })
        .fail(function (err) {
        alert("error " + err);
    })
        .always(function () {
        //
    });
}
// see http://www.dotnetcurry.com/showarticle.aspx?ID=939 for example of typescript with knockout
//# sourceMappingURL=app.js.map
var Cell = /** @class */ (function () {
    function Cell(no, x, y, ch, visible, firstChar) {
        this.no = ko.observable(0);
        this.x = ko.observable(0);
        this.y = ko.observable(0);
        this.ch = ko.observable(0);
        this.visibleImg = ko.observable(true);
        this.firstChar = ko.observable(true);
        this.no(no);
        this.x(x);
        this.y(y);
        this.ch(ch);
        this.visibleImg(visible);
        this.firstChar(firstChar);
    }
    Cell.prototype.setVisible = function (visible) {
        this.visibleImg(visible);
    };
    Cell.prototype.setChar = function (ch) {
        this.ch(ch);
    };
    return Cell;
}());
//# sourceMappingURL=Cell.js.map
/// <reference path="Tool.ts" />
var Editor = /** @class */ (function () {
    function Editor() {
        this.screenWidth = 32;
        this.screenHeight = 24;
        this.selectCell1 = -1;
        this.selectCell2 = -1;
        this.width = ko.observable(this.screenWidth).extend({ min: 1, max: this.screenWidth });
        this.height = ko.observable(this.screenHeight).extend({ min: 1, max: this.screenHeight });
        this.ts = new ToolArray();
        this.grid = ko.observable(true);
        this.spriteArray = ko.observableArray([]);
        this.mousedown = ko.observable(false);
    }
    Editor.prototype.init = function () {
        for (var y = 0; y <= this.height() - 1; y++) // will init spriteArray to 32x24 
         {
            for (var x = 0; x <= this.width() - 1; x++) {
                //this.spriteArray.push(new Cell(x + y * this.screenWidth, x, y, this.backgroundCharacter(), true, (x == 0)));
                this.spriteArray.push(new Cell(x + y * this.screenWidth, x, y, this.ts.getTool("BG").imageCharacter(), true, (x == 0)));
            }
        }
        var lc = new LoadCharSet();
        lc.load_chars();
        $('#editor').mousedown(function () {
            ed.mousedown(true);
        }).mouseup(function () {
            ed.mousedown(false);
        });
        $('#decimalData').text('');
    };
    Editor.prototype.GetCellByOrdinal = function (ordinal) {
        return ko.utils.arrayFirst(this.spriteArray(), function (cell) {
            return cell.no() === ordinal;
        });
    };
    Editor.prototype.moveLeft = function () {
        for (var y = 0; y <= 24 - 1; y++) {
            for (var x = 1; x <= 32 - 1; x++) {
                var readCell = this.GetCellByOrdinal(x + y * 32);
                var writeCell = this.GetCellByOrdinal(x - 1 + y * 32);
                if (readCell && writeCell) {
                    writeCell.ch(readCell.ch());
                }
            }
            var clearCell = this.GetCellByOrdinal(32 - 1 + y * 32);
            if (clearCell) {
                clearCell.ch(this.ts.getTool("BG").imageCharacter());
            }
        }
    };
    Editor.prototype.moveUp = function () {
        for (var x = 0; x <= 32 - 1; x++) {
            for (var y = 1; y <= 24 - 1; y++) {
                var readCell = this.GetCellByOrdinal(x + (y) * 32);
                var writeCell = this.GetCellByOrdinal(x + (y - 1) * 32);
                if (readCell && writeCell) {
                    writeCell.ch(readCell.ch());
                }
            }
            var clearCell = this.GetCellByOrdinal(x + (24 - 1) * 32);
            if (clearCell) {
                clearCell.ch(this.ts.getTool("BG").imageCharacter());
            }
        }
    };
    Editor.prototype.moveDown = function () {
        for (var x = 32 - 1; x >= 0; x--) {
            for (var y = 24 - 1; y >= 0; y--) {
                var readCell = this.GetCellByOrdinal(x + y * 32);
                var writeCell = this.GetCellByOrdinal(x + (y + 1) * 32);
                if (readCell && writeCell) {
                    writeCell.ch(readCell.ch());
                }
            }
            var clearCell = this.GetCellByOrdinal(x);
            if (clearCell) {
                clearCell.ch(this.ts.getTool("BG").imageCharacter());
            }
        }
    };
    Editor.prototype.moveRight = function () {
        for (var y = 0; y <= 24 - 1; y++) {
            for (var x = 32 - 1; x >= 1; x--) {
                var readCell = this.GetCellByOrdinal(x - 1 + y * 32);
                var writeCell = this.GetCellByOrdinal(x + y * 32);
                if (readCell && writeCell) {
                    writeCell.ch(readCell.ch());
                }
            }
            var clearCell = this.GetCellByOrdinal(0 + y * 32);
            if (clearCell) {
                clearCell.ch(this.ts.getTool("BG").imageCharacter());
            }
        }
    };
    Editor.prototype.changedWidth = function (newWidth) {
        for (var y = 0; y <= 24 - 1; y++) {
            for (var x = 0; x <= 32 - 1; x++) {
                var cell = this.GetCellByOrdinal(x + y * 32);
                if (cell) {
                    if (cell.visibleImg() != (x < newWidth && y < this.height())) {
                        cell.setVisible(x < newWidth);
                    }
                }
            }
        }
    };
    Editor.prototype.changedHeight = function (newHeight) {
        for (var y = 0; y <= 24 - 1; y++) {
            for (var x = 0; x <= 32 - 1; x++) {
                var cell = this.GetCellByOrdinal(x + y * 32);
                if (cell) {
                    if (cell.visibleImg() != (y < newHeight && x < this.width())) {
                        cell.setVisible(y < newHeight);
                    }
                }
            }
        }
    };
    Editor.prototype.setCharacter = function (ch) {
        switch (this.ts.selectedTool) {
            case 'FG':
                this.ts.getTool(this.ts.selectedTool).imageCharacter(ch);
                break;
            case 'BG':
                this.ts.getTool(this.ts.selectedTool).imageCharacter(ch);
                break;
        }
    };
    Editor.prototype.setDrawMode = function (toolName) {
        ed.selectTool(toolName);
    };
    Editor.prototype.flipArea = function () {
        if ((this.selectCell1 != -1) && (this.selectCell2 != -1)) {
            var firstCell = this.selectCell1;
            var secondCell = this.selectCell2;
            if (this.selectCell1 > this.selectCell2) {
                firstCell = this.selectCell2;
                secondCell = this.selectCell1;
            }
            var firstCellY = Math.floor(firstCell / 32);
            var firstCellX = firstCell - firstCellY * 32;
            var secondCellY = Math.floor(secondCell / 32);
            var secondCellX = secondCell - secondCellY * 32;
            var halfWayX = Math.floor((secondCellX - firstCellX) / 2) + firstCellX;
            for (var y = firstCellY; y <= secondCellY; y++) {
                for (var x = firstCellX; x <= halfWayX; x++) {
                    var rightCell = secondCellX - x + firstCellX;
                    var leftSideCellCh = this.GetCellByOrdinal(x + y * 32).ch();
                    var rightSideCellCh = this.GetCellByOrdinal(rightCell + y * 32).ch();
                    this.GetCellByOrdinal(rightCell + y * 32).ch(this.flipCell(leftSideCellCh));
                    this.GetCellByOrdinal(x + y * 32).ch(this.flipCell(rightSideCellCh));
                }
            }
        }
    };
    Editor.prototype.flipCell = function (cell) {
        var result = cell;
        switch (cell) {
            case 1:
                result = 2;
                break;
            case 2:
                result = 1;
                break;
            case 4:
                result = 135;
                break;
            case 135:
                result = 4;
                break;
            case 5:
                result = 133;
                break;
            case 133:
                result = 5;
                break;
            case 6:
                result = 134;
                break;
            case 134:
                result = 4;
                break;
            case 7:
                result = 132;
                break;
            case 132:
                result = 7;
                break;
            case 17:
                result = 16;
                break;
            case 16:
                result = 17;
                break;
            case 19:
                result = 18;
                break;
            case 18:
                result = 19;
                break;
            case 146:
                result = 147;
                break;
            case 147:
                result = 146;
                break;
            case 144:
                result = 145;
                break;
            case 145:
                result = 144;
                break;
            case 129:
                result = 130;
                break;
            case 130:
                result = 129;
                break;
        }
        return result;
    };
    Editor.prototype.pasteArea = function (cellNo) {
        // overlap may have unknown effect
        if ((this.selectCell1 != -1) && (this.selectCell2 != -1)) {
            var firstCell = this.selectCell1;
            var secondCell = this.selectCell2;
            if (this.selectCell1 > this.selectCell2) {
                firstCell = this.selectCell2;
                secondCell = this.selectCell1;
            }
            var firstCellY = Math.floor(firstCell / 32);
            var firstCellX = firstCell - firstCellY * 32;
            var secondCellY = Math.floor(secondCell / 32);
            var secondCellX = secondCell - secondCellY * 32;
            if (firstCellX > secondCellX) {
                var tempX = firstCellX;
                firstCellX = secondCellX;
                secondCellX = tempX;
            }
            var newCellY = Math.floor(cellNo / 32);
            var newCellX = cellNo - newCellY * 32;
            for (var y = firstCellY; y <= secondCellY; y++) {
                for (var x = firstCellX; x <= secondCellX; x++) {
                    var pasteCellCh = this.GetCellByOrdinal(x + y * 32).ch();
                    var newx = newCellX + x - firstCellX;
                    var newy = newCellY + y - firstCellY;
                    this.GetCellByOrdinal(newx + newy * 32).ch(pasteCellCh);
                }
            }
            this.resetSelectArea();
        }
    };
    Editor.prototype.selectArea = function (cellNo) {
        this.selectCell2 = this.selectCell1;
        this.selectCell1 = cellNo;
        if ((this.selectCell1 != -1) && (this.selectCell2 != -1)) {
            var firstCell = this.selectCell1;
            var secondCell = this.selectCell2;
            if (this.selectCell1 > this.selectCell2) {
                firstCell = this.selectCell2;
                secondCell = this.selectCell1;
            }
            var firstCellY = Math.floor(firstCell / 32);
            var firstCellX = firstCell - firstCellY * 32;
            var secondCellY = Math.floor(secondCell / 32);
            var secondCellX = secondCell - secondCellY * 32;
            if (firstCellX > secondCellX) {
                var tempX = firstCellX;
                firstCellX = secondCellX;
                secondCellX = tempX;
            }
            $('#matrix li').css("background-color", "#ccc");
            $('#matrix img').css("opacity", "1");
            for (var y = firstCellY; y <= secondCellY; y++) {
                for (var x = firstCellX; x <= secondCellX; x++) {
                    var cellNo = y * 32 + x + 1;
                    $('#matrix li:nth-child(' + cellNo + ')').css("background-color", "blue");
                    $('#matrix li:nth-child(' + cellNo + ') img').css("opacity", ".7");
                }
            }
        }
    };
    Editor.prototype.resetSelectArea = function () {
        this.selectCell1 = -1;
        this.selectCell2 = -1;
        $('#matrix li').css("background-color", "#ccc");
        $('#matrix img').css("opacity", "1");
    };
    Editor.prototype.setCell = function (cellNo, checkDown) {
        if (ed.mousedown() || !checkDown) {
            var charToUse = this.ts.getTool(ed.ts.selectedTool).imageCharacter();
            if (this.ts.selectedTool == 'FILL') {
                return;
            }
            if (this.ts.selectedTool == 'SELECT') {
                this.selectArea(cellNo);
                return;
            }
            if (this.ts.selectedTool == 'PASTE') {
                this.pasteArea(cellNo);
                return;
            }
            if (this.ts.selectedTool == 'HFLIP') {
                return;
            }
            if (this.ts.selectedTool == 'INV') {
                charToUse = (this.GetCellByOrdinal(cellNo).ch() + 128) % 256;
            }
            var cell = this.GetCellByOrdinal(cellNo);
            if (cell) {
                cell.setChar(charToUse);
            }
        }
    };
    Editor.prototype.showData = function () {
        var data = '';
        $('#decimalData').val('');
        if (this.width() != 32) {
            data = data + '' + this.width().toString() + ',' + this.height().toString() + String.fromCharCode(13);
        }
        for (var y = 0; y < this.height(); y++) {
            for (var x = 0; x < this.width(); x++) {
                var i = x + y * 32;
                var cell = this.GetCellByOrdinal(i);
                if (cell) {
                    data = data + cell.ch() + String.fromCharCode(13);
                }
            }
        }
        $('#decimalData').val(data);
    };
    Editor.prototype.checkForSpriteSize = function (lineNo, lines) {
        if (lines.length > 0) {
            var firstLine = lines[0];
            if (firstLine.indexOf(',') > 0) {
                var params = firstLine.split(",");
                if (params.length > 1) {
                    try {
                        var width = parseInt(params[0]);
                        var height = parseInt(params[1]);
                        this.width(width);
                        this.height(height);
                        lineNo++;
                        return lineNo;
                    }
                    catch (err) {
                        alert('Error in first line for sprite width and height');
                    }
                }
            }
        }
        this.width(32);
        this.height(24);
        return lineNo;
    };
    Editor.prototype.fillScreen = function (fillCh) {
        for (var y = 0; y <= this.height() - 1; y++) {
            for (var x = 0; x <= this.width() - 1; x++) {
                var cell = this.GetCellByOrdinal(x + y * 32);
                if (cell) {
                    cell.ch(fillCh);
                }
            }
        }
    };
    Editor.prototype.loadData = function () {
        var data1 = $('#decimalData').val();
        this.fillScreen(0);
        var lines = data1.split(/\n/);
        var l = 0;
        l = this.checkForSpriteSize(l, lines);
        for (var y = 0; y <= this.height() - 1; y++) {
            for (var x = 0; x <= this.width() - 1; x++) {
                var ch = 0;
                if (l < lines.length) {
                    ch = this.tryParseInt(lines[l], ch);
                }
                if (this.height() != 24) { // i.e. a sprite not full screen size
                    var spritexpos = (l - 1) % this.width();
                    var spriteypos = Math.floor((l - 1) / this.width());
                    var cell = this.GetCellByOrdinal(spritexpos + spriteypos * 32);
                    if (cell) {
                        cell.ch(ch);
                    }
                }
                else {
                    var cell = this.GetCellByOrdinal(x + y * 32);
                    if (cell) {
                        cell.ch(ch);
                    }
                }
                l++;
            }
        }
    };
    Editor.prototype.tryParseInt = function (str, defaultValue) {
        var retValue = defaultValue;
        if (str !== null) {
            if (str.length > 0) {
                if (!isNaN(str)) {
                    retValue = parseInt(str);
                }
            }
        }
        return retValue;
    };
    return Editor;
}());
//# sourceMappingURL=Editor.js.map
var Input = /** @class */ (function () {
    function Input() {
        this.bombCount = 0;
    }
    // continuous key being held down
    Input.prototype.getKeyIndex = function (key) {
        var i = Input.keysMonitored.indexOf(key);
        return i;
    };
    Input.prototype.ClearKeys = function () {
        for (var i = 0; i < Input.keyArray.length; i++) {
            Input.keyArray[i] = false;
        }
    };
    Input.prototype.KeyUp = function (key) {
        var i = this.getKeyIndex(key);
        if (i >= 0) {
            Input.keyArray[i] = false;
        }
    };
    Input.prototype.KeyDown = function (key) {
        var i = this.getKeyIndex(key);
        var x = key.charCodeAt(0);
        if (i >= 0) {
            Input.keyArray[i] = true;
        }
    };
    Input.prototype.isKeyDown = function (key) {
        var i = this.getKeyIndex(key);
        return Input.keyArray[i];
    };
    Input.prototype.getZxCharFromAscii = function (s) {
        // allow ascii chars to be passed in and converted to zx chars, otherwise use charcodeat
        var ch = 0;
        switch (s[0]) {
            case ' ':
                ch = 0;
                break;
            case '-':
                ch = 22;
                break;
            case '/':
                ch = 24;
                break;
            case '.':
                ch = 27;
                break;
            case '<':
                ch = 19;
                break;
            case '>':
                ch = 18;
                break;
            case ':':
                ch = 14;
                break;
            case ',':
                ch = 26;
                break;
            case '"':
                ch = 11;
                break;
            case '£':
                ch = 12;
                break;
            case '$':
                ch = 13;
                break;
            case '*':
                ch = 23;
                break;
            case '(':
                ch = 16;
                break;
            case ')':
                ch = 17;
                break;
            case ';':
                ch = 25;
                break;
            case '.':
                ch = 27;
                break;
            case '?':
                ch = 15;
                break;
            case '=':
                ch = 20;
                break;
            case '+':
                ch = 21;
                break;
            case '0':
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
            case '8':
            case '9':
                ch = s.charCodeAt(0) - 20;
                break;
            default:
                if (((s[0] >= 'a') && (s[0] <= 'z')) || (s[0] >= 'A') && (s[0] <= 'Z')) {
                    ch = s.toUpperCase().charCodeAt(0) - 27;
                    break; // adjust from ascii to zx81 char set
                }
                else {
                    if ((s.charCodeAt(0) >= 0 || s.charCodeAt(0) <= 63) || (s.charCodeAt(0) >= 128 || s.charCodeAt(0) <= 191)) {
                        ch = s.charCodeAt(0);
                    }
                    else {
                        ch = 0;
                    }
                }
        }
        return ch;
    };
    // single key presses
    Input.prototype.keyPress = function (keycode) {
        var key = this.getZxCharFromAscii(keycode);
        var isnumber = (keycode >= '0' && keycode <= '9');
        var isalphabet = (keycode >= 'a' && keycode <= 'z') ||
            (keycode >= 'A' && keycode <= 'Z');
        var iszxpunctuation = keycode == '"' ||
            keycode == '£' ||
            keycode == '$' ||
            keycode == '*' ||
            keycode == '(' ||
            keycode == ')' ||
            keycode == ':' ||
            keycode == ';' ||
            keycode == ',' ||
            keycode == '.' ||
            keycode == '<' ||
            keycode == '>' ||
            keycode == '?' ||
            keycode == '=' ||
            keycode == '+' ||
            keycode == '-' ||
            keycode == '/';
        var valid = isnumber || keycode == ' ' || isalphabet || iszxpunctuation;
        var shiftPressed = this.isKeyDown(String.fromCharCode(Input.shift));
        var ctrlPressed = this.isKeyDown(String.fromCharCode(Input.ctrl));
        if (valid) {
            if (shiftPressed && !iszxpunctuation) {
                key = key + 128;
            }
            else {
                if (ctrlPressed && key < 128) {
                    key = key + 128;
                }
            }
            ed.setCharacter(key);
        }
    };
    Input.down = 90; // for keys used during game
    Input.up = 65;
    Input.left = 188;
    Input.right = 190;
    Input.fireLeft = 75; // k
    Input.fireRight = 76; // l
    Input.shift = 16;
    Input.m = 77;
    Input.space = 32;
    Input.ctrl = 0; // ?
    Input.keysMonitored = String.fromCharCode(Input.down) +
        String.fromCharCode(Input.up) +
        String.fromCharCode(Input.left) +
        String.fromCharCode(Input.right) +
        String.fromCharCode(Input.fireRight) +
        String.fromCharCode(Input.fireLeft) +
        String.fromCharCode(Input.shift) +
        String.fromCharCode(Input.m) +
        String.fromCharCode(Input.space) +
        String.fromCharCode(Input.ctrl);
    Input.keyArray = new Array(7);
    return Input;
}());
//# sourceMappingURL=input.js.map
var LoadCharSet = /** @class */ (function () {
    function LoadCharSet() {
    }
    LoadCharSet.prototype.load_chars = function () {
        var callbackf = function (data, textStatus, xhr) {
            var allowedChars = new Array(256);
            for (var c = 0; c < 256; c++) {
                allowedChars[c] = false;
            }
            var chars = data.split('\n');
            for (var c = 0; c <= chars.length; c++) {
                try {
                    if (chars[c] && (chars[c].indexOf("gif") > 0)) {
                        var i = parseInt(chars[c].replace('bitmap', '').replace('.gif\r', ''));
                        allowedChars[i] = true;
                    }
                }
                catch (err) {
                    alert('error' + err);
                }
            }
            for (var i = 0; i <= 255; i++) {
                if (allowedChars[i]) { // TODO : not nice
                    $("#characters").append("<img onclick='ed.setCharacter(" + i + ");' alt='' title='" + c + "' id='char_" + c + "' src='/graphics/bitmap" + i + ".gif' />");
                }
            }
            $("#characters").append("<hr />");
        };
        var scr = this.load_file('chars.txt', callbackf);
    };
    LoadCharSet.prototype.load_file = function (fileName, callback) {
        function getData() {
            return $.ajax({
                url: '/data/' + fileName,
                type: 'GET',
                dataType: "text",
                async: false,
                cache: false
            });
        }
        getData().done(callback);
        getData().fail(function () { alert('failed to get chars'); });
    };
    return LoadCharSet;
}());
//# sourceMappingURL=LoadCharSet.js.map
var Tool = /** @class */ (function () {
    function Tool(toolname, selected, txt, txtcolor, backgroundColor, imageCharacter, title) {
        this.selected = ko.observable(false);
        this.txt = ko.observable('');
        this.txtcolor = ko.observable('');
        this.backgroundColor = ko.observable('');
        this.imageCharacter = ko.observable(0);
        this.toolname = ko.observable('');
        this.title = ko.observable('');
        this.selectUrl = ko.computed(function () {
            return 'ed.ts.selectTool(\'' + this.toolname() + '\');';
        }, this);
        this.selected(selected);
        this.txt(txt);
        this.backgroundColor(backgroundColor);
        this.txtcolor(txtcolor);
        this.imageCharacter(imageCharacter);
        this.toolname(toolname);
        this.title(title);
    }
    Tool.prototype.toolSelected = function (selected) {
        this.selected(selected);
    };
    return Tool;
}());
var ToolArray = /** @class */ (function () {
    function ToolArray() {
        this.tools = ko.observableArray([]);
        this.selectedTool = '';
    }
    ToolArray.prototype.setupTools = function () {
        var foreground = new Tool("FG", false, '', '', '', 128, "Foreground");
        var background = new Tool("BG", false, '', '', '', 0, "Background");
        var inverse = new Tool("INV", false, '', '#FFF' /* white */, '#000' /* black */, 255, "Invert");
        var fillscreen = new Tool("FILL", false, '', '#FFF' /* white */, '#000' /* black */, 254, "Fill with background");
        var select = new Tool("SELECT", false, '', '#FFF' /* white */, '#000' /* black */, 250, "Select area. Click top left then bottom right");
        var paste = new Tool("PASTE", false, '', '#FFF' /* white */, '#000' /* black */, 252, "Paste selected area");
        var fliphorizontal = new Tool("HFLIP", false, '', '#FFF' /* white */, '#000' /* black */, 248, "Horizontal flip selected area");
        this.tools.push(foreground);
        this.tools.push(background);
        this.tools.push(inverse);
        this.tools.push(fillscreen);
        this.tools.push(select);
        this.tools.push(paste);
        this.tools.push(fliphorizontal);
        this.selectTool("FG");
    };
    ToolArray.prototype.getTool = function (toolName) {
        for (var i = 0; i < this.tools().length; i++) {
            if (this.tools()[i].toolname() == toolName) {
                return this.tools()[i];
            }
        }
    };
    ToolArray.prototype.selectTool = function (toolName) {
        if (toolName == 'HFLIP') {
            ed.flipArea();
        }
        if (toolName != 'PASTE') {
            ed.resetSelectArea();
        }
        if (toolName == 'FILL') { // move selectTool to editor.ts
            if (window.confirm("Are you sure you want to fill the screen with the background character?")) {
                ed.fillScreen(ed.ts.getTool("BG").imageCharacter());
            }
            toolName = "BG"; // for if want to do another fill
        }
        this.selectedTool = toolName;
        for (var i = 0; i < this.tools().length; i++) {
            this.tools()[i].toolSelected(this.tools()[i].toolname() == toolName);
        }
    };
    return ToolArray;
}());
//# sourceMappingURL=Tool.js.map